/**
 * Copyright (c) 2009-2012 EBM WebSourcing, 2012-2013 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.system.repository;

import java.io.File;
import java.io.FilenameFilter;

/**
 * @author Roland Naudin - EBM WebSourcing
 */
public final class RepositoryFileFilter implements FilenameFilter {

    private final String entityId;

    /**
     * Default constructor.
     * @param entityId
     */
    public RepositoryFileFilter(String entityId) {
        super();
        this.entityId = entityId;
    }

    /*
     * (non-Javadoc)
     * 
     * @see java.io.FilenameFilter#accept(java.io.File, java.lang.String)
     */
    public boolean accept(File dir, String name) {

        if (name.startsWith(this.entityId)) {
            final String suffix = name.substring(this.entityId.length());
            if (suffix.matches("-[\\d]{2}-[\\d]{2}-[\\d]{4}-[\\d]{9}")) {
                return true;
            }
        }

        return false;
    }

}
