/**
 * Copyright (c) 2009-2012 Capgemini, 2009-2012 EBM WebSourcing, 2012-2013 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.transport.platform.nio.client;

import org.ow2.petals.microkernel.transport.platform.nio.selector.NioClient;

/**
 * Interface of the Fractal component associated to the NIO Client pool.
 * @author Christophe DENEUX - Capgemini Sud
 */
public interface NioClientObjectPool {
	
	public final static String NIO_CLIENT_OBJECT_ITF = "clientsPool";
	public NioClient borrowObject(final String targetContainerName) throws Exception;
	public void returnObject(final String targetContainerName, final NioClient clientConnection) throws Exception;
}
