/**
 * Copyright (c) 2005-2012 EBM WebSourcing, 2012-2013 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.jbi.component.context;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import javax.xml.namespace.QName;

import org.junit.Before;
import org.junit.Test;
import org.ow2.petals.microkernel.jbi.component.mock.MockComponentContext;

/**
 * Test of the ComponentContextForInstallation.
 * @author ddesjardins - EBM WebSourcing
 */
public class ComponentContextForInstallationTest {
    private ComponentContextForInstallation componentContextForInstallation = null;

    private MockComponentContext componentContext = null;

    @Before
    public void setUp() {
        componentContext = new MockComponentContext();
        componentContextForInstallation = new ComponentContextForInstallation(componentContext);
    }

    @Test
    public void testActivateEndpoint() {
        try {
            componentContextForInstallation.activateEndpoint(new QName("service"), "endpoint");
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testDeactivateEndpoint() {
        try {
            componentContextForInstallation.deactivateEndpoint(null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testDeregisterExternalEndpoint() {
        try {
            componentContextForInstallation.deregisterExternalEndpoint(null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetComponentName() {
        try {
            componentContextForInstallation.getComponentName();
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetDeliveryChannel() {
        try {
            componentContextForInstallation.getDeliveryChannel();
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetEndpoint() {
        try {
            componentContextForInstallation.getEndpoint(null, null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetEndpointDescriptor() {
        try {
            componentContextForInstallation.getEndpointDescriptor(null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetEndpoints() {
        try {
            componentContextForInstallation.getEndpoints(null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetEndpointsForService() {
        try {
            componentContextForInstallation.getEndpointsForService(null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetExternalEndpoints() {
        try {
            componentContextForInstallation.getExternalEndpoints(null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetExternalEndpointsForService() {
        try {
            componentContextForInstallation.getExternalEndpointsForService(null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetLogger() {
        try {
            componentContextForInstallation.getLogger("test", "test");
            assertTrue(componentContext.isGetLogger());
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetWorkspaceRoot() {
        assertNull(componentContextForInstallation.getWorkspaceRoot());
    }

    @Test
    public void testRegisterExternalEndpoint() {
        try {
            componentContextForInstallation.registerExternalEndpoint(null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testResolveEndpointReference() {
        try {
            componentContextForInstallation.resolveEndpointReference(null);
            fail();
        } catch (IllegalStateException e) {
            // Do nothing
        } catch (Exception e) {
            fail();
        }
    }

    @Test
    public void testGetInstallRoot() {
        assertEquals(componentContextForInstallation.getInstallRoot(), "root");
    }

    @Test
    public void testGetMBeanNames() {
        componentContextForInstallation.getMBeanNames();
        assertTrue(componentContext.isGetMBeanNames());
    }

    @Test
    public void testGetMBeanServer() {
        componentContextForInstallation.getMBeanServer();
        assertTrue(componentContext.isGetMBeanServer());
    }

    @Test
    public void testGetTransactionManager() {
        componentContextForInstallation.getTransactionManager();
        assertTrue(componentContext.isGetTransactionManager());
    }

    @Test
    public void testGetNamingContext() {
        componentContextForInstallation.getNamingContext();
        assertTrue(componentContext.isGetNamingContext());
    }

}
